﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" class="concept">
    <head>
        <link href="../Resources/TableStyles/Default-Table.css" rel="stylesheet" MadCap:stylesheetType="table" /><title>Configuring LDAP Authentication</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Configuring LDAP Authentication</h1>
        <h2>Overview</h2>
        <p>You can use Lightweight Directory Access Protocol (LDAP) external authentication protocol to authenticate users in Saviynt Identity Governance and Administration (IGA). The user is authenticated against an LDAP directory server using the user name and password provided by the client.</p>
        <p>When a user attempts to access IGA that is configured for external authentication, IGA sends the username and password to the LDAP server for authentication. Once authenticated, the LDAP protocol is used to identify the user on IGA.</p>
        <h2>Setting Up LDAP Authentication</h2>
        <p>This section describes how to configure LDAP as an authentication system for users logging in to IGA.</p>
        <h2 id="ConfiguringLDAPAuthentication-Prerequisites">Prerequisites</h2>
        <p>The following are the prerequisites for configuring LDAP as the authentication system:</p>
        <ul>
            <li>
                <p>An LDAP v3 compliant server.</p>
            </li>
            <li>
                <p>LDAP Server is configured and running in the installed directory service.</p>
            </li>
            <li>
                <p>Establish connection with IGA and LDAP server.</p>
            </li>
        </ul>
        <h2 id="ConfiguringLDAPAuthentication-ConfigureLDAPinEIC">Configure LDAP in IGA</h2>
        <p>The <label class="filename-path">AuthenticationConfig.groovy</label> file contains the settings for configuring LDAP in IGA. You can manage this file in IGA via the <strong>Configuration Files</strong> page.</p>
        <p>To configure LDAP in IGA, perform the following steps:</p>
        <ol>
            <li>
                <p>Log in to IGA.</p>
            </li>
            <li MadCap:conditions="Default.v55X">
                <p>Click <b>Admin &gt; Settings &gt; Configuration Files</b>.</p>
                <p>The <strong>Configuration Files</strong> page is displayed.<br /></p>
            </li>
            <li MadCap:conditions="Default.v2020X,Default.v2021X">
                <p>On the top right of the home page, click the <strong>Applications</strong> icon, and select <strong>Admin</strong>.</p>
            </li>
            <li MadCap:conditions="Default.v2020X,Default.v2021X">
                <p>Click the <strong>Menu</strong> icon.</p>
            </li>
            <li MadCap:conditions="Default.v2020X,Default.v2021X">
                <p>Click <strong>Settings &gt; Configuration Files</strong>.<br />The <strong>Configuration Files</strong> page is displayed.</p>
            </li>
            <li>
                <p>Select the <strong>AuthenticationConfig.groovy</strong> file which you want to modify and click the <strong>Edit </strong>icon.<br />The&#160;<strong>Create File</strong> dialog box is displayed.</p>
                <p>
                    <img src="../Resources/Images/SA21.png" />
                    <br />
                </p>
            </li>
            <li>
                <p>Scroll down to the <strong>LDAP</strong> section of the <label class="filename-path">AuthenticationConfig.groovy</label> file and specify the LDAP configuration properties.</p>
                <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                    <p class="note"> Ensure that the <label class="param-value">grails.plugin.springsecurity.saml.active</label> parameter is set to <label class="param-value">false</label><br /></p>
                </div>
            </li>
        </ol>
        <div class="table-wrap">
            <table class="TableStyle-Default-Table" style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" cellspacing="0">
                <col style="width: 380px;" class="TableStyle-Default-Table-Column-Column1" />
                <col style="width: 380px;" class="TableStyle-Default-Table-Column-Column1" />
                <thead>
                    <tr class="TableStyle-Default-Table-Head-Header1">
                        <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Property</th>
                        <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                    </tr>
                </thead>
                <tbody>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.active</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify <label class="param-value">true</label> to enable LDAP authentication.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.context.managerDn</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the username to connect to the directory that refers to the username of an account or a service account with the necessary permissions to access the directory. It must be a&#160;<strong>distinguishedName (DN).&#160;</strong></p>
                            <p class="table-text">For example:</p>
                            <p class="table-text"><span class="attr">''CN=OUAdmin,OU=Users,OU=SaviyntTraining,DC=corpAD,DC=saviynt,DC=com'</span>
                            </p>
                            <p class="table-text">It is imperative to understand the permissions, which must be given to an account or a service account as this username needs to perform CRUD operations, which are in the scope of AD being done from IGA.</p>
                            <p class="table-text">Ensure that the&#160;<strong>least privileges</strong>&#160;are assigned to an account or a service account for performing basic CRUD (Create, Read, Update, and Delete) operations on Accounts/Groups object along with Password management. It is recommended to assign '<strong>Enterprise Admin</strong>' group (core AD group) to an account or a&#160; service account and it should be a member of '<strong>Domain Users</strong>' group (core AD group) as well.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.context.managerPassword</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the password of the user with a privileged Service account to connect to LDAP.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.context.server</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the URL or IP address to connect to the LDAP server. Enter the URL in the following format: <br /><span class="attr">ldap://&lt;host_name&gt;:&lt;port_number&gt;</span></p>
                            <p>For example:</p>
                            <p><span class="attr">ldap://ldap.abccompany.com:389</span>
                            </p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.authorities.ignorePartialResultException</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">If you are using Active Directory, then specify <label class="param-value">true</label> to ignore <label class="filename-path">PartialResultException</label> being thrown in searches.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.search.base</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the location of the User list in your LDAP server. For example:</p>
                            <p class="table-text"><span class="attr">'cn=users,dc=corpAD,dc=saviynt,dc=com'</span>
                            </p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.search.filter</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the filter expression to search the user. For example:</p>
                            <ul>
                                <li>
                                    <p class="table-text">Active Directory: <label class="param-value">"sAMAccountname={0}"</label></p>
                                </li>
                                <li>
                                    <p class="table-text">Other LDAP Server: <label class="param-value">'(uid={0})'</label></p>
                                </li>
                            </ul>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.search.searchSubtree</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify <label class="param-value">true</label> to search the entire subtree as identified by context, if set to <label class="param-value">false</label> then only searches the level identified by the context.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.auth.hideUserNotFoundExceptions  </p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify <label class="param-value">false</label>to throw UsernameNotFoundException message.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.providerNames</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify this option to skip attempting to load from database and only use LDAP.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.mapper.userDetailsClass</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify options for mapping LDAP attributes to user details data.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.userLookup.usernamePropertyName </p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify this parameter if the sAMAccountName is not same as the username. Default value is <label class="param-value">username</label>.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.useRememberMe</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify <label class="param-value">true</label> to to use persistent logins.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.authorities.groupSearchBase</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify Base DN for group search. If this is not specified, Users Base DN is used.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.authorities.retrieveGroupRoles</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify <label class="param-value">true</label>to retreive roles based on group membership.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyB-Column1-Body1">
                            <p class="table-text">grails.plugin.springsecurity.ldap.authorities.retrieveDatabaseRoles</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyA-Column1-Body1">
                            <p class="table-text">Specify <label class="param-value">true</label> to assign application-specific roles to users in the database.</p>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <p><strong>Sample AuthenticationConfig.groovy File</strong>
        </p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: PlainText;">/* LDAP */
grails.plugin.springsecurity.ldap.active=true
grails.plugin.springsecurity.ldap.context.managerDn = 'cn=admin,cn=users,dc=corpAD,dc=saviynt,dc=com'
grails.plugin.springsecurity.ldap.context.managerPassword = 'xxxxxx'
grails.plugin.springsecurity.ldap.context.server = 'ldap://ldap.abccompany.com:389' // if port 636 then ldaps
grails.plugin.springsecurity.ldap.authorities.ignorePartialResultException = true // typically needed for Active Directory
grails.plugin.springsecurity.ldap.search.base = 'cn=users,dc=corpAD,dc=saviynt,dc=com'
grails.plugin.springsecurity.ldap.search.filter= "sAMAccountname={0}" // for Active Directory you need this
grails.plugin.springsecurity.ldap.search.searchSubtree = true
grails.plugin.springsecurity.ldap.auth.hideUserNotFoundExceptions = false
//grails.plugin.springsecurity.ldap.search.attributesToReturn = ['mail','displayName']
//grails.plugin.springsecurity.providerNames = ['ldapAuthProvider' , 'daoAuthenticationProvider' , 'anonymousAuthenticationProvider', 'rememberMeAuthenticationProvider'] // specify this when you want to skip attempting to load from db and only use LDAP
grails.plugin.springsecurity.ldap.mapper.userDetailsClass = 'com.saviynt.ecm.identitywarehouse.domain.Users'
//grails.plugin.springsecurity.userLookup.usernamePropertyName = 'systemUserName'
grails.plugin.springsecurity.ldap.useRememberMe = false
//grails.plugin.springsecurity.ldap.authorities.groupSearchBase = 'OU=US'
//grails.plugin.springsecurity.ldap.authorities.retrieveGroupRoles = false
grails.plugin.springsecurity.ldap.authorities.retrieveDatabaseRoles = true</MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p>5. Click <strong>Submit</strong>.</p>
        <p>6. Restart the service. The change will not take effect until the service is restarted.</p>
        <h2 id="ConfiguringLDAPAuthentication-ConfiguringPasswordSynchronizationonLDAP">Configuring Password Synchronization on LDAP</h2>
        <p>To synchronize passwords from IGA to an LDAP directory, perform the following step:</p>
        <ol>
            <li>
                <p>Log in to IGA.</p>
            </li>
            <li>
                <p>On the top right of the home page, click the <strong>Applications</strong> icon, and select <strong>Admin</strong>.</p>
            </li>
            <li>
                <p>Click the <strong>Menu</strong> icon.</p>
            </li>
            <li>
                <p>Click <strong>Global Configurations</strong>.</p>
            </li>
            <li>
                <p>Select <strong>Preferences</strong> and then select the <strong>Enable Change password</strong> parameter to display <strong>Change Password</strong> in the IGA profile menu.</p>
            </li>
            <li>
                <p><strong>Global Configurations &gt; &#160;Tasks.</strong>
                </p>
            </li>
            <li>
                <p>Scroll down to the <strong>Settings</strong> section and do the following:</p>
                <ul>
                    <li>
                        <p><strong>Endpoints to Synchronize Password for Self</strong>: Select the LDAP application for which the password needs to be synchronized.</p>
                    </li>
                    <li>
                        <p><strong>Endpoints to Synchronize Password for Others</strong>: Select the LDAP application for which the password needs to be synchronized.<br />For example, if Active Directory is specified in Endpoints to Synchronize Password, a task to change your password in this endpoint is generated. After the task is approved, the password is changed.</p>
                    </li>
                </ul>
            </li>
        </ol>
        <h1 id="ConfiguringLDAPAuthentication-UnderstandingPasswordManagementScenarios">Understanding Password Management Scenarios</h1>
        <p>This section provides details about the various use-cases related to:</p>
        <ul>
            <li>
                <p>First Time logging in to IGA</p>
            </li>
            <li>
                <p>Using Change Password functionality</p>
            </li>
            <li>
                <p>Password expiring in IGA or in LDAP/AD System</p>
            </li>
        </ul>
        <h3>Scenario 1: Log In to IGA for the First Time</h3>
        <p>When you log in to IGA for the first time, you will be prompted to change your password for the following scenarios:</p>
        <ul>
            <li>
                <p>Password in IGA has expired (<span class="attr">PASSWORDEXPIRED =1</span>) </p>
            </li>
            <li>
                <p>LDAP/AD password has expired (<span class="attr">pwdLastSet =0</span>)</p>
            </li>
        </ul>
        <p>To reset the password, perform the following steps:</p>
        <ol>
            <li>
                <p>In a browser, enter the IGA URL:<br /><label class="filename-path">https://&lt;domain_name&gt;/ECM </label><br />Example, <span class="attr">http://myexampleorg.saviyntcloud.com/ECM</span>).</p>
            </li>
            <li>
                <p>Enter your username and password to log in for the first time. </p>
            </li>
            <li>
                <p>Specify the new password and confirm the new password and click <strong>Submit</strong>.&#160;<br />The newly specified password is updated for IGA. Additionally, the newly specified password is updated for the LDAP/AD system too.</p>
                <p>
                    <img src="../Resources/Images/SA23.PNG" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                </p>
            </li>
        </ol>
        <h3>Scenario 2: Changing Password from the Profile Menu in IGA</h3>
        <p>To change your password from IGA, perform the following steps:</p>
        <ol>
            <li>
                <p>Log in to IGA.</p>
            </li>
            <li>
                <p>Click on the Profile menu on the top right and then click <strong>Change Password</strong>.  <br />The <strong>Change Password </strong>page is displayed.</p>
                <p>
                    <img src="../Resources/Images/SA24.PNG" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                    <br />
                </p>
            </li>
            <li>
                <p>Enter the New Password and then confirm the new password.</p>
            </li>
            <li>
                <p>Click <strong>Submit</strong>.<br />The newly specified password is updated in IGA and the LDAP/AD system.&#160;</p>
            </li>
        </ol>
        <h3>Scenario 3: Password Expiring in IGA or LDAP/AD</h3>
        <p>If your password in IGA has expired (<span class="attr">PASSWORDEXPIRED =1</span>) or your LDAP/AD password has expired (<span class="attr">pwdLastSet = 0</span>), you are forced to choose a new password in IGA on the next login.</p>
        <p>To reset the IGA password, perform the following steps:</p>
        <ol>
            <li>
                <p>Log in to the IGA UI using the username and password.<br />You will not be able to log in to IGA as the password is expired. forced to choose a new password to finish logging in to the system.<br />The authentication of your expired password is performed and if successful a Reset Password screen is displayed.</p>
            </li>
            <li>
                <p>Enter the New Password and then confirm the new password.</p>
            </li>
            <li>
                <p>Click <strong>Submit</strong>.<br />The newly specified password is updated in IGA and the LDAP/AD system.&#160;</p>
            </li>
        </ol>
    </body>
</html>